{ 000115-2.PAS                                                              }
{ 2000-01-15 programmeerimisolmpiaadi 2. lesande lahendus                 }
{    LIGUD                                                                 }
{ Testitud: TP 6.0, FPC 0.99.10                                             }
{ Meelis Kull                                                               }

type tPunkt = record
         x, y : longint;
       end;
     tLoik = record
         A, B : tPunkt;
       end;

var L : array[1..10] of tLoik; {ette antud ligud}
    N : integer; {likude arv}
    i, j : integer;
    tyhik : boolean;
    F : text;

function LP(L:tLoik;P:tPunkt):integer;
{
Funktsiooni LP vrtus nitab seda, kuidas paikneb punkt P ligu L suhtes.
Kujutleme, et vaatame punktist L.A punkti L.B suunas.
Siis LP vrtus on
 -1, kui punkt P on paremal
  1, kui punkt P on vasakul
  0, kui punkt P on ligul
  1, kui punkt P on otse ees prast punkti P.B (ees)
 -1, kui punkt P on samal sirgel selja taga
}
var dx1,dy1,dx2,dy2:longint;
  begin
    dx1:=L.B.x-L.A.x;  dy1:=L.B.y-L.A.y;
    dx2:= P.x -L.A.x;  dy2:= P.y -L.A.y;
    if dy2*dx1<dx2*dy1 then
      LP:=-1 {paremal} else
    if dy2*dx1>dx2*dy1 then
      LP:=1 {vasakul} else
      begin {ligu otspunktid ja P on kik hel sirgel}
        if (dx1*dx2<0) or (dy1*dy2<0) then
          LP:=-1 {taga} else
        if dx1*dx1+dy1*dy1<dx2*dx2+dy2*dy2 then
          LP:=1 {ees} else
          LP:=0; {ligul}
      end;
  end;

function yhispunkte(L1,L2:tLoik):boolean;
{
Kui likudel L1 ja L2 on hiseid punkte, siis on vrtuseks
TRUE, vastasel korral on vrtuseks FALSE.
}
  begin
    yhispunkte:=( LP(L1,L2.A) * LP(L1,L2.B) <=0 ) and
                ( LP(L2,L1.A) * LP(L2,L1.B) <=0 );
  end;

{ PHIPROGRAMM }
begin
  assign(F,'LOIGUD.SIS');
  reset(F);
  readln(F,N);
  for i:=1 to N do
   with L[i] do
    readln(F,A.x,A.y,B.x,B.y);{loeme sisse i.ligu otspunktide koordinaadid}
  close(F);

  assign(F,'LOIGUD.VAL');
  rewrite(F);
  for i:=1 to N do
    begin
      tyhik:=FALSE; {rea algusesse pole thikut vaja}
      for j:=1 to N do
        if yhispunkte(L[i],L[j]) then
          begin
            if tyhik then write(F,' ');
            write(F,j); {kirjutame j, sest ligul i on
                         liguga j hiseid punkte}
            tyhik:=TRUE; {enne jrgmist arvu peab thiku panema}
          end;
      writeln(F);
    end;
  close(F);
end.
