{ 000115-5.PAS                                                              }
{ 2000-01-15 programmeerimisolmpiaadi 5. lesande lahendus                 }
{    KARBID                                                                 }
{ Testitud: TP 6.0, FPC 0.99.10                                             }
{ Ahto Truu                                                                 }

const
   sisf = 'KARBID.SIS';                                  { sisendfaili nimi }
   valf = 'KARBID.VAL';                                 { vljundfaili nimi }
   maxn = 100;                            { maksimaalne lubatud karpide arv }

type
   karp = record                                           { he karbi info }
      n : integer;                { nende karpide arv, mille sisse ta mahub }
      a : array [1..maxn] of integer;               { nende karpide numbrid }
      p : integer;                                { maksimaalse jada pikkus }
      k : integer;                        { kustkaudu maksimaalne jada tuli }
   end;
   karbid = record                                     { kigi karpide info }
      n : integer;                                            { karpide arv }
      a : array [1..maxn] of karp;                           { karpide info }
   end;

{ loeb sisendandmed }
procedure loe_sisend (var k : karbid);
var f : text; i : integer;
begin
   assign (f, sisf); reset (f);
   readln (f, k.n);
   for i := 1 to k.n do begin
      k.a[i].n := 0;
      while not seekeoln (f) do begin
         k.a[i].n := k.a[i].n + 1;
         read (f, k.a[i].a[k.a[i].n]);
      end;
      readln (f);
   end;
   close (f);
end;

{ leiab iga karbi jaoks maksimaalse selle sisse tehtava jada }
procedure leia_lahendus (var k : karbid);
var i, j : integer; m : boolean;
begin
      { teeme algseisu: iga karp on 1-elemendiline jada }
   for i := 1 to k.n do begin
      k.a[i].p := 1;
      k.a[i].k := 0;
   end;

      { nd hakkame lainet levitama }
   repeat
      m := false;                                 { veel pole htki muutust }
      for i := 1 to k.n do
         for j := 1 to k.a[i].n do
            if not (k.a[k.a[i].a[j]].p > k.a[i].p) then begin
               k.a[k.a[i].a[j]].p := k.a[i].p + 1;
               k.a[k.a[i].a[j]].k := i;
               m := true;
            end;
   until not m;                           { lpetame, kui enam muutusi pole }
end;

{ teeb vljundi }
procedure tee_valjund (var k : karbid);
var f : text; i, m : integer;
   { trkib maksmiaalse karbis x lppeva jada }
   procedure tryki (x : integer);
   begin
      if k.a[x].k = 0 then
           write (f, x)
      else begin
           tryki (k.a[x].k);
         write (f, ' ', x);
      end;
   end;
begin
      { leiame maksimaalse jadapikkuse }
   m := 1;
   for i := 1 to k.n do
      if k.a[i].p > k.a[m].p then
           m := i;

      { teeme vljundfaili }
   assign (f, valf); rewrite (f);
   writeln (f, k.a[m].p);
   tryki (m);
   close (f);
end;

var
   k : karbid;
begin                                                        { phiprogramm }
   loe_sisend (k);
   leia_lahendus (k);
   tee_valjund (k);
end.
