{ kontroll.pas                                                              }
{ 2000-01-15 programmeerimisolmpiaadi 5. lesande testija                  }
{    KARBID                                                                 }
{ Ahto Truu                                                                 }

{$I-}

const
   maxn = 100;                            { maksimaalne lubatud karpide arv }

type
   karp = record                                           { he karbi info }
      n : integer;                { nende karpide arv, mille sisse ta mahub }
      a : array [1..maxn] of integer;               { nende karpide numbrid }
      p : integer;                                { maksimaalse jada pikkus }
   end;
   karbid = record                                     { kigi karpide info }
      n : integer;                                            { karpide arv }
      a : array [1..maxn] of karp;                           { karpide info }
      p : integer;                                { maksimaalse jada pikkus }
   end;

procedure loe_sisend (var k : karbid);
var f : text; i : integer;
begin
   assign (f, paramstr (1)); reset (f);
   readln (f, k.n);
   for i := 1 to k.n do begin
      k.a[i].n := 0;
      while not seekeoln (f) do begin
         k.a[i].n := k.a[i].n + 1;
         read (f, k.a[i].a[k.a[i].n]);
      end;
      readln (f);
   end;
   close (f);
end;

procedure leia_tsyklid (var k : karbid);
var i, ii, j : integer; m : boolean; a : array [1..maxn] of boolean;
begin
   for i := 1 to k.n do begin
      for j := 1 to k.n do
         a[j] := false;
      for j := 1 to k.a[i].n do
         a[k.a[i].a[j]] := true;
      repeat
         m := false;
         for ii := 1 to k.n do
            if a[ii] then
               for j := 1 to k.a[ii].n do
                  if not a[k.a[ii].a[j]] then begin
                     a[k.a[ii].a[j]] := true;
                     m := true;
                  end;
      until not m;
      if a[i] then begin
         writeln ('Vigane test: sisendandmetes on tskkel!');
         halt (1);
      end;
   end;
end;

procedure leia_lahendus (var k : karbid);
var i, j, x, y : integer; m : boolean;
begin
   for i := 1 to k.n do
      k.a[i].p := 1;
   repeat
      m := false;
      for i := 1 to k.n do
         for j := 1 to k.a[i].n do
            if not (k.a[k.a[i].a[j]].p > k.a[i].p) then begin
               k.a[k.a[i].a[j]].p := k.a[i].p + 1;
               m := true;
            end;
   until not m;
   k.p := 0;
   for i := 1 to k.n do
      if k.a[i].p > k.p then
         k.p := k.a[i].p;
   x := 0;
   for i := 1 to k.n do
      if k.a[i].p = k.p then
         if x = 0 then
            x := i
         else begin
            writeln ('Mrkus: ige vastus pole hene');
            exit;
         end;
   while k.a[x].p > 1 do begin
      y := 0;
      for i := 1 to k.n do
         if k.a[i].p = k.a[x].p - 1 then
            for j := 1 to k.a[i].n do
               if k.a[i].a[j] = x then
                  if y = 0 then
                     y := i
                  else begin
                     writeln ('Mrkus: ige vastus pole hene');
                     exit;
                  end;
      x := y;
   end;
   writeln ('Mrkus: ige vastus on hene');
end;

procedure loe_valjund (var k : karbid);
var f : text; n, i, j, k1, k2 : integer; t : boolean;
begin
   assign (f, paramstr (2)); reset (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' avamisel');
      halt (1);
   end;

   read (f, n);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;
   if not seekeoln (f) then begin
      writeln ('Liigsed smbolid faili ', paramstr (2), ' 1. rea lpus');
      halt (1);
   end;
   if not eoln (f) then begin
      writeln ('Liigsed thikud faili ', paramstr (2), ' 1. rea lpus');
   end;
   readln (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;

   i := 0;
   while not seekeoln (f) do begin
      read (f, k2);
      if ioresult > 0 then begin
         writeln ('Viga faili ', paramstr (2), ' lugemisel');
         halt (1);
      end;
      if i > 0 then begin
         t := false;
         for j := 1 to k.a[k1].n do
            if k.a[k1].a[j] = k2 then
               t := true;
         if not t then begin
            writeln ('Lubamatu sisalduvus ', k1, ' -> ', k2, ' failis ', paramstr (2));
            halt (1);
         end;
      end;
      i := i + 1;
      k1 := k2;
   end;
   if not eoln (f) then begin
      writeln ('Liigsed thikud faili ', paramstr (2), ' 2. rea lpus');
   end;
   readln (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      halt (1);
   end;

   if not seekeof (f) then begin
      writeln ('Liigsed smbolid faili ', paramstr (2), ' lpus');
      halt (1);
   end;
   if not eof (f) then begin
      writeln ('Liigsed thikud faili ', paramstr (2), ' lpus');
   end;
   close (f);

   if n < k.p then
      writeln ('Jada pikkus (', n, ') ei ole optimaalne (', k.p, ')');
   if i <> n then
      writeln ('Karpide arv jadas (', i, ') ei vasta deklareeritule (', n, ')');
end;

var
   k : karbid;
begin
   if paramcount <> 2 then begin
      writeln ('Sntaks on: ', paramstr (0), ' sisendfail vljundfail');
      halt (1);
   end;

   loe_sisend (k);
   leia_tsyklid (k);
   leia_lahendus (k);
   loe_valjund (k);

   writeln ('Korras');
end.